﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Diagnostics;
using System.Linq;
using System.Text;
using Infragistics.Win.UltraWinListView;
using System.Reflection;
using System.Drawing;

namespace UltraListViewCustScrollEventReflection
{
    public partial class MyCustomListView : UltraListView
    {

        public delegate void VerticalScrollHandler(object sender, EventArgs   e);
        public event VerticalScrollHandler ScrollVertical;
        internal int prevValue =0;

        public MyCustomListView()
        {
            InitializeComponent();
            
        }
        
        protected override void OnInvalidated(System.Windows.Forms.InvalidateEventArgs e)
        {
            base.OnInvalidated(e);

            Assembly assemblyListView = Assembly.GetAssembly(typeof(UltraListView));
            Type listViewType = assemblyListView.GetType("Infragistics.Win.UltraWinListView.UltraListView");
            FieldInfo scrollManager = listViewType.GetField("scrollManager", BindingFlags.Instance | BindingFlags.NonPublic | BindingFlags.GetField);
            object scrollManagerValue = scrollManager.GetValue(this);

            Type UltraListViewScrollManagerType = scrollManagerValue.GetType();
            FieldInfo scrollPositionFiel = UltraListViewScrollManagerType.GetField("scrollPosition", BindingFlags.Instance | BindingFlags.NonPublic | BindingFlags.GetField);
            if (prevValue != ((Point)scrollPositionFiel.GetValue(scrollManagerValue)).Y && ScrollVertical != null)
            {
                ScrollVertical(this, new EventArgs());
                prevValue = ((Point)scrollPositionFiel.GetValue(scrollManagerValue)).Y;
            }
        }
    }
}
